:
# NAME:
#	ndconv - convert named.conf to named.boot
#
# SYNOPSIS:
#	ndconv named.conf > named.boot
#
# DESCRIPTION:
#	This script provides a function for extracting zone
#	definitions from BIND-8 config files and outputting them in a
#	form suitable for a BIND-4 config file.  It has several uses.
#	
# AUTHOR:
#	Simon J. Gerraty <sjg@crufty.net>
#

# RCSid:
#	$Id: ndconv.sh,v 1.5 2001/08/30 07:48:37 sjg Exp $
#
#	@(#)Copyright (c) 1997-2001 Simon J. Gerraty.
#	All rights reserved.
#	
#	This software is the property of Simon J. Gerraty.
#	It may be used only in accordance with the conditions outlined
#	in the accompanying LICENSE file. If your distribution does
#	not contain a LICENSE file, then you have no rights to use
#	this software and should contact sales@crufty.net to obtain a
#	licensed distribution.
#	
#	This software is provided "AS IS" in the hope that it will be
#	of use.  Since it is not possible to anticipate all possible
#	use of this software, there is absolutely NO WARRANTY.
#
#	Please forward bug reports and fixes to help@crufty.net
#

get_zones() {
	tr -d '";{}' < $1 | grep -v '^[ 	]*//' |
	awk '/include/ {
		print $0
	}
	/directory/ {
		print $0
	}
	/zone/ {
		z=$2; f=""; t=""; m="";
	}
	/masters/ {
		m=$2
	}
	/type/ {
		t=$NF
	}
	/file/ {
		f=$NF
	}
	{
		if (f != "") {
			if (t == "slave") {
				if (m != "") {
					print t,z,f,m
                                        f=""
				}
			} else {
			        print t,z,f
                                f=""
			}
		}
	}' | while read t z f m
	do
		case "$t" in
		include)	test -f $z || z=${dir:-.}/$z; get_zones $z;;
		directory)	dir=$z; echo $t $z;;
		master)		echo primary $z $f;;
		slave)		echo secondary $z $m $f;;
		hint)		echo . $f;;
		esac
	done
}

case $0 in
*ndconv*) get_zones $*;;
esac

